//*****************************************************************************
//*****************************************************************************
//  FILENAME: PWM16_BP01.h
//   Version: 2.5, Updated on 2008/11/17 at 11:19:12
//  Generated by PSoC Designer ???
//
//  DESCRIPTION: PWM16 User Module C Language interface file
//               for the 22/24/27/29xxx PSoC family of devices
//-----------------------------------------------------------------------------
//  Copyright (c) Cypress MicroSystems 2000-2004. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************

#include <m8c.h>

#pragma fastcall16 PWM16_BP01_EnableInt
#pragma fastcall16 PWM16_BP01_DisableInt
#pragma fastcall16 PWM16_BP01_Start
#pragma fastcall16 PWM16_BP01_Stop
#pragma fastcall16 PWM16_BP01_wReadCounter              // Read  DR0
#pragma fastcall16 PWM16_BP01_WritePeriod               // Write DR1
#pragma fastcall16 PWM16_BP01_wReadPulseWidth           // Read  DR2
#pragma fastcall16 PWM16_BP01_WritePulseWidth           // Write DR2

// The following symbols are deprecated.
// They may be omitted in future releases
//
#pragma fastcall16 wPWM16_BP01_ReadCounter              // Read  DR0 (Deprecated)
#pragma fastcall16 wPWM16_BP01_ReadPulseWidth           // Read  DR2 (Deprecated)


//-------------------------------------------------
// Prototypes of the PWM16_BP01 API.
//-------------------------------------------------

extern void PWM16_BP01_EnableInt(void);                  // Proxy Class 1
extern void PWM16_BP01_DisableInt(void);                 // Proxy Class 1
extern void PWM16_BP01_Start(void);                      // Proxy Class 1
extern void PWM16_BP01_Stop(void);                       // Proxy Class 1
extern WORD PWM16_BP01_wReadCounter(void);               // Proxy Class 2
extern void PWM16_BP01_WritePeriod(WORD wPeriod);        // Proxy Class 1
extern WORD PWM16_BP01_wReadPulseWidth(void);            // Proxy Class 1
extern void PWM16_BP01_WritePulseWidth(WORD wPulseWidth);// Proxy Class 1

// The following functions are deprecated.
// They may be omitted in future releases
//
extern WORD wPWM16_BP01_ReadCounter(void);            // Deprecated
extern WORD wPWM16_BP01_ReadPulseWidth(void);         // Deprecated


//-------------------------------------------------
// Constants for PWM16_BP01 API's.
//-------------------------------------------------

#define PWM16_BP01_CONTROL_REG_START_BIT       ( 0x01 )
#define PWM16_BP01_INT_REG_ADDR                ( 0x0df )
#define PWM16_BP01_INT_MASK                    ( 0x20 )


//--------------------------------------------------
// Constants for PWM16_BP01 user defined values
//--------------------------------------------------

#define PWM16_BP01_PERIOD                      ( 0x51a )
#define PWM16_BP01_PULSE_WIDTH                 ( 0x28d )


//-------------------------------------------------
// Register Addresses for PWM16_BP01
//-------------------------------------------------

#pragma ioport  PWM16_BP01_COUNTER_LSB_REG: 0x050          //DR0 Count register LSB
BYTE            PWM16_BP01_COUNTER_LSB_REG;
#pragma ioport  PWM16_BP01_COUNTER_MSB_REG: 0x054          //DR0 Count register MSB
BYTE            PWM16_BP01_COUNTER_MSB_REG;
#pragma ioport  PWM16_BP01_PERIOD_LSB_REG:  0x051          //DR1 Period register LSB
BYTE            PWM16_BP01_PERIOD_LSB_REG;
#pragma ioport  PWM16_BP01_PERIOD_MSB_REG:  0x055          //DR1 Period register MSB
BYTE            PWM16_BP01_PERIOD_MSB_REG;
#pragma ioport  PWM16_BP01_COMPARE_LSB_REG: 0x052          //DR2 Compare register LSB
BYTE            PWM16_BP01_COMPARE_LSB_REG;
#pragma ioport  PWM16_BP01_COMPARE_MSB_REG: 0x056          //DR2 Compare register MSB
BYTE            PWM16_BP01_COMPARE_MSB_REG;
#pragma ioport  PWM16_BP01_CONTROL_LSB_REG: 0x053          //Control register LSB
BYTE            PWM16_BP01_CONTROL_LSB_REG;
#pragma ioport  PWM16_BP01_CONTROL_MSB_REG: 0x057          //Control register MSB
BYTE            PWM16_BP01_CONTROL_MSB_REG;
#pragma ioport  PWM16_BP01_FUNC_LSB_REG:    0x150          //Function register LSB
BYTE            PWM16_BP01_FUNC_LSB_REG;
#pragma ioport  PWM16_BP01_FUNC_MSB_REG:    0x154          //Function register MSB
BYTE            PWM16_BP01_FUNC_MSB_REG;
#pragma ioport  PWM16_BP01_INPUT_LSB_REG:   0x151          //Input register LSB
BYTE            PWM16_BP01_INPUT_LSB_REG;
#pragma ioport  PWM16_BP01_INPUT_MSB_REG:   0x155          //Input register MSB
BYTE            PWM16_BP01_INPUT_MSB_REG;
#pragma ioport  PWM16_BP01_OUTPUT_LSB_REG:  0x152          //Output register LSB
BYTE            PWM16_BP01_OUTPUT_LSB_REG;
#pragma ioport  PWM16_BP01_OUTPUT_MSB_REG:  0x156          //Output register MSB
BYTE            PWM16_BP01_OUTPUT_MSB_REG;
#pragma ioport  PWM16_BP01_INT_REG:       0x0df            //Interrupt Mask Register
BYTE            PWM16_BP01_INT_REG;


//-------------------------------------------------
// PWM16_BP01 Macro 'Functions'
//-------------------------------------------------

#define PWM16_BP01_Start_M \
   ( PWM16_BP01_CONTROL_LSB_REG |=  PWM16_BP01_CONTROL_REG_START_BIT )

#define PWM16_BP01_Stop_M  \
   ( PWM16_BP01_CONTROL_LSB_REG &= ~PWM16_BP01_CONTROL_REG_START_BIT )

#define PWM16_BP01_EnableInt_M   \
   M8C_EnableIntMask(  PWM16_BP01_INT_REG, PWM16_BP01_INT_MASK )

#define PWM16_BP01_DisableInt_M  \
   M8C_DisableIntMask( PWM16_BP01_INT_REG, PWM16_BP01_INT_MASK )

// end of file PWM16_BP01.h
