//****************************************
//	radio-alarm.c   WIA[
//			Copyright by S.Asakura
//****************************************
#include 	<m8c.h>
#include 	"PSoCAPI.h" 	// PSoC API definitions for all User Modules
#include	"printf.h"		// printf to
#include	"message.h"		// bZ[W\
#include	"rtc-inner.h"	// RTCA^C NbN
#include	"rtc-alarm.h"	// RTCA[
#include	"kjs.h" 		// ً}nk񃋁[`

//*******************************
//		֐vg^Cv錾
//*******************************
#define 	FIRST_FLG		// ŏɕϐ̒`A2ڈȍ~͊Oϐ錾邽߂̃tO
#include	"radio-alarm.h"	// WIA[


//*******************************
//		萔 `
//*******************************


//*******************************
//		O[oϐ
//*******************************
	unsigned char	radioAlmPoutDatBuf;	// WIA[o̓|[gf[^obt@
	unsigned char	rHighDT[16] = R_ALM_INI_H;	// WIA[High ftHgl
	unsigned char	rLowDT[16]  = R_ALM_INI_L;	// WIA[Low  ftHgl

	unsigned char	rHighSecond;	// 0-59 secondsA[HIGH
	unsigned char	rHighMinute;	// 0-59 minutesA[HIGH
	unsigned char	rHighHour;		// 0-23 hoursA[HIGH
	unsigned char	rHighDate;		// 1-31 daysA[HIGH
	unsigned char	rHighWkDay;		// 0-6 (Sunday=0, Saturday=6)A[HIGH
	unsigned char	rHighMonth;		// 1-12 monthsA[HIGH
	unsigned short	rHighYear;		// 0-9999 yearA[HIGH

	unsigned char	rLowSecond;		// 0-59 secondsA[LOW
	unsigned char	rLowMinute;		// 0-59 minutesA[LOW
	unsigned char	rLowHour;		// 0-23 hoursA[LOW
	unsigned char	rLowDate;		// 1-31 daysA[LOW
	unsigned char	rLowWkDay;		// 0-6 (Sunday=0, Saturday=6)A[LOW
	unsigned char	rLowMonth;		// 1-12 monthsA[LOW
	unsigned short	rLowYear;		// 0000-9999 yearA[LOW


//=============================================================================


//*******************************
// WIA[ݒ S\
//*******************************
void disp_radioAlm_Set(void) {
	extern	unsigned char	rHighDT[16];		// WIA[High ftHgl , 0000b
	extern	unsigned char	rLowDT[16] ;		// WIA[Low  ftHgl , 0001b
	extern	unsigned char	radioAlmStat;		// WIA[o͏   , 0=Low_OFF, 1=High_ON
	extern	unsigned char	radioAlmEnable;		// WIA[Enable , 0=Disable, 1=Enable

	UART_1_CPutString("Radio-Alarm = ");
	if (radioAlmEnable == ON_HIGH_1) {
		msg_Enable();			// \_Enable
	} else {
		msg_Disable();			// \_Disable
	}
	UART_1_PutCRLF();			// s(CR,LF)

	msg_HighSet();				// \_High Set =
	UART_1_PutString( rHighDT );
	UART_1_PutCRLF();			// s(CR,LF)
	msg_LowSet();				// \_Low Set =
	UART_1_PutString( rLowDT );
	UART_1_PutCRLF();			// s(CR,LF)

	UART_1_CPutString(" R_Alm Stat = ");
	if (radioAlmStat == ON_HIGH_1) {
		msg_ON_HIGH_1();		// \_ON_HIGH_1
	} else {
		msg_OFF_LOW_0();		// \_OFF_LOW_0
	}
	UART_1_PutCRLF();		// s(CR,LF)
}

//*******************************
// WIA[ \iKJSDŁAKۂ̏o͂Ƃ͑ΉȂj
//*******************************
void disp_radioAlm_Stat(void) {
	extern	unsigned char	radioAlmStat;			// WIA[ , 0=Low_OFF, 1=High_ON
	extern	unsigned char	preRadioAlmStat;		// ÕWIA[

	if ( radioAlmStat != preRadioAlmStat) {
		UART_1_CPutString(" , R_Alm-");
		if (radioAlmStat == ON_HIGH_1) {
			UART_1_CPutString("ON");
		} else {
			UART_1_CPutString("OFF");
		}
		preRadioAlmStat = radioAlmStat;		// ÕWIA[
	} // end if
}

//*******************************
// WIA[
//*******************************
void init_radioAlarm(void) {
	extern	unsigned char	radioAlmStat;		// WIA[o͏
	extern	unsigned char	preRadioAlmStat;	// ÕWIA[o͏
	extern	unsigned char	radioAlmEnable;		// WIA[Enable , 0=Disable, 1=Enable

	radioAlmStat    = OFF_LOW_0;	// WIA[   , 0=Low_OFF, 1=High_ON
	preRadioAlmStat = radioAlmStat;	// ÕWIA[
	radioAlmEnable = OFF_LOW_0;		// WIA[Enable , 0=Disable, 1=Enable
	chg_rDT_num(&rHighDT[0], ON_HIGH_1);	// WIA[t_ݒl_lϊ
	chg_rDT_num( &rLowDT[0], OFF_LOW_0);	// WIA[t_ݒl_lϊ
}

//********************
// HELP WIA[ R}h('R')
//********************
void help_radioAlarm(void) {
	UART_1_CPutString(" RH(DateTime) : Radio-Alarm-High");
	UART_1_PutCRLF();		// s(CR,LF)
	UART_1_CPutString(" RL(DateTime) : Radio-Alarm-Low");
	UART_1_PutCRLF();		// s(CR,LF)
	msg_Help_DateTime();	// \_HELP_DateTime
	UART_1_CPutString(" REx : Radio-Alarm-Enable , x=0:Disable , x=1:Enable");
	UART_1_PutCRLF();		// s(CR,LF)
}

//*******************************
// WIA[ R}h('R') 
//*******************************
void cmdBR_radioAlarm(unsigned char *sPtr) {
	extern	unsigned char	radioAlmEnable;	// WIA[Enable , 0=Disable, 1=Enable
	unsigned char *strPtr;

	set_prtdev_sio(); 				// \uSIO(UART)ɂ
	strPtr = sPtr;
	strPtr++;
	switch (*strPtr) {
		case 'H' : 		// A[HIGHݒ
		case 'h' : 
			strPtr++;
			if (chk_AlmFormat(strPtr)) {					// A[t_tH[}bg`FbN
				copyStr_rtcAlmSet( &rHighDT[0], strPtr);	// RTCA[ݒ_Rs[(15+00 p)
				chg_rDT_num( &rHighDT[0], ON_HIGH_1);		// WIA[t_ݒl_lϊ
				disp_radioAlm_Set();						// WIA[ݒ S\
			} else {
				msg_FmtError();			// \_Format_Error
				help_radioAlarm();		// HELP WIA[ R}h('R')
				disp_radioAlm_Set();	// WIA[ݒ S\
			} // end if 
			break;
		case 'L' : 		// A[LOWݒ
		case 'l' : 
			strPtr++;
			if (chk_AlmFormat(strPtr)) {					// A[t_tH[}bg`FbN
				copyStr_rtcAlmSet( &rLowDT[0], strPtr);		// RTCA[ݒ_Rs[(15+00 p)
				chg_rDT_num( &rLowDT[0], OFF_LOW_0);		// WIA[t_ݒl_lϊ
				disp_radioAlm_Set();						// WIA[ݒ S\
			} else {
				msg_FmtError();			// \_Format_Error
				help_radioAlarm();		// HELP WIA[ R}h('R')
				disp_radioAlm_Set();	// WIA[ݒ S\
			} // end if 
			break;
		case 'E' : 		// A[Enableݒ
		case 'e' : 
			strPtr++;
			if (*strPtr == '1') {
				radioAlmEnable = ON_HIGH_1; 	// WIA[Enable , 0=Disable, 1=Enable
			} else {
				radioAlmEnable = OFF_LOW_0; 	// WIA[Enable , 0=Disable, 1=Enable
			} // end if 
			disp_radioAlm_Set();		// WIA[ݒ S\
			break;
		default : 
			msg_InvalCmd();		// \_R}h
			help_radioAlarm();	// HELP WIA[ R}h('R')
			break;
	} // end switch cmd[1]
}

//*******************************
// WIA[t_ݒl_lϊ
//*******************************
void chg_rDT_num(unsigned char *aStr, unsigned char onoff) {
	extern	unsigned char	rHighSecond;	// 0-59 secondsA[HIGH
	extern	unsigned char	rHighMinute;	// 0-59 minutesA[HIGH
	extern	unsigned char	rHighHour;		// 0-23 hoursA[HIGH
	extern	unsigned char	rHighDate;		// 1-31 daysA[HIGH
	extern	unsigned char	rHighWkDay;		// 0-6 (Sunday=0, Saturday=6)A[HIGH
	extern	unsigned char	rHighMonth;		// 1-12 monthsA[HIGH
	extern	unsigned short	rHighYear;		// 0-9999 yearA[HIGH

	extern	unsigned char	rLowSecond;		// 0-59 secondsA[LOW
	extern	unsigned char	rLowMinute;		// 0-59 minutesA[LOW
	extern	unsigned char	rLowHour;		// 0-23 hoursA[LOW
	extern	unsigned char	rLowDate;		// 1-31 daysA[LOW
	extern	unsigned char	rLowWkDay;		// 0-6 (Sunday=0, Saturday=6)A[LOW
	extern	unsigned char	rLowMonth;		// 1-12 monthsA[LOW
	extern	unsigned short	rLowYear;		// 0-9999 yearA[LOW

	unsigned char	*strPtr;
	unsigned short	nYear;
	unsigned char	nMonth , nDate , nWkDay, nLeap;
	unsigned char	nHour , nMin , nSec;

	// N[0-3]A[4-5]A[6-7]Aj[8]AA[9-10]A[11-12]Ab[13-14]A00[15]
	strPtr = aStr;	// N
	if (*strPtr == '?' || *strPtr == 'X' || *strPtr == 'x') {
		nYear = DONT_CARE;	// N
	} else {
		nYear   = (unsigned short)(((*strPtr++) - '0') * 1000);
		nYear  += (unsigned short)(((*strPtr++) - '0') *  100);
		nYear  += (unsigned short)(((*strPtr++) - '0') *   10);
		nYear  += (unsigned short)(((*strPtr  ) - '0')       );
	} // end if

	strPtr = aStr + 4;	// 
	if (*strPtr == '?' || *strPtr == 'X' || *strPtr == 'x') {
		nMonth = DONT_CARE;	// 
	} else {
		nMonth  = (((*strPtr++) - '0') * 10);
		nMonth += (((*strPtr  ) - '0')     );
	} // end if

	strPtr = aStr + 6;	// 
	if (*strPtr == '?' || *strPtr == 'X' || *strPtr == 'x') {
		nDate = DONT_CARE;	// 
	} else {
		nDate   = (((*strPtr++) - '0') * 10);
		nDate  += (((*strPtr  ) - '0')     );
	} // end if

	strPtr = aStr + 8;	// j
	if (*strPtr == '?' || *strPtr == 'X' || *strPtr == 'x') {
		nWkDay = DONT_CARE;	//  Don't Care
	} else {
		nWkDay  =  ((*strPtr)   - '0');
	} // end if

	strPtr = aStr + 9;	// 
	if (*strPtr == '?' || *strPtr == 'X' || *strPtr == 'x') {
		nHour = DONT_CARE;	// 
	} else {
		nHour = (((*strPtr++) - '0') * 10);
		nHour+= (((*strPtr  ) - '0')     );
	} // end if

	strPtr = aStr + 11;	// 
	if (*strPtr == '?' || *strPtr == 'X' || *strPtr == 'x') {
		nMin = DONT_CARE;	// 
	} else {
		nMin  = (((*strPtr++) - '0') * 10);
		nMin += (((*strPtr  ) - '0')     );
	} // end if

	strPtr = aStr + 13;	// b
	if (*strPtr == '?' || *strPtr == 'X' || *strPtr == 'x') {
		nSec = DONT_CARE;	// b
	} else {
		nSec  = (((*strPtr++) - '0') * 10);
		nSec += (((*strPtr)   - '0')     );
	} // end if

	if (onoff == 1) {
		rHighYear   = nYear;
		rHighMonth  = nMonth;
		rHighDate   = nDate;
		rHighWkDay  = nWkDay;
		rHighSecond = nSec;			// b
		rHighMinute = nMin;			// 
		rHighHour   = nHour;		// 
	} else {
		rLowYear   = nYear;
		rLowMonth  = nMonth;
		rLowDate   = nDate;
		rLowWkDay  = nWkDay;
		rLowSecond = nSec;			// b
		rLowMinute = nMin;			// 
		rLowHour   = nHour;			// 
	} // end if onoff
}

//*******************************
// WIA[_`FbN
//*******************************
void chk_radioAlarm(void) {
	extern	unsigned char	second;		// 0-59 seconds
	extern	unsigned char	minute;		// 0-59 minutes
	extern	unsigned char	hour;		// 0-23 hours
	extern	unsigned char	date;		// 1-31 days
	extern	unsigned char	wkDay;		// 0-6 (Sunday=0, Saturday=6)
	extern	unsigned char	month;		// 1-12 months
	extern	unsigned short	year;		// 0-9999 year

	extern	unsigned char	rHighSecond;	// 0-59 secondsA[HIGH
	extern	unsigned char	rHighMinute;	// 0-59 minutesA[HIGH
	extern	unsigned char	rHighHour;		// 0-23 hoursA[HIGH
	extern	unsigned char	rHighDate;		// 1-31 daysA[HIGH
	extern	unsigned char	rHighWkDay;		// 0-6 (Sunday=0, Saturday=6)A[HIGH
	extern	unsigned char	rHighMonth;		// 1-12 monthsA[HIGH
	extern	unsigned short	rHighYear;		// 0-9999 yearA[HIGH

	extern	unsigned char	rLowSecond;		// 0-59 secondsA[LOW
	extern	unsigned char	rLowMinute;		// 0-59 minutesA[LOW
	extern	unsigned char	rLowHour;		// 0-23 hoursA[LOW
	extern	unsigned char	rLowDate;		// 1-31 daysA[LOW
	extern	unsigned char	rLowWkDay;		// 0-6 (Sunday=0, Saturday=6)A[LOW
	extern	unsigned char	rLowMonth;		// 1-12 monthsA[LOW
	extern	unsigned short	rLowYear;		// 0-9999 yearA[LOW

	extern	unsigned char	radioAlmStat;		// WIA[ , 0=Low_OFF, 1=High_ON
												//iKJSDŁAKۂ̏o͂Ƃ͑ΉȂj
	extern	unsigned char	radioAlmEnable;		// WIA[Enable , 0=Disable, 1=Enable

	if ( (radioAlmStat != OFF_LOW_0) && (SW_PORT & K_RST_SW_BIT) == OFF_LOW_0 ) {	// x񃊃ZbgXCb`
		UART_1_CPutString(" , RST-SW");		// \̓s UART_1_CPutString g
		radioAlmStat = OFF_LOW_0;			// WIA[ , 0=Low_OFF, 1=High_ON
	} else if (radioAlmEnable == ON_HIGH_1) {
		if (radioAlmStat == OFF_LOW_0) {
			if (((rHighYear   == DONT_CARE) || (rHighYear   == year)  ) && 
				((rHighMonth  == DONT_CARE) || (rHighMonth  == month) ) && 
				((rHighDate   == DONT_CARE) || (rHighDate   == date)  ) && 
				((rHighWkDay  == DONT_CARE) || (rHighWkDay  == wkDay) ) && 
				((rHighHour   == DONT_CARE) || (rHighHour   == hour)  ) && 
				((rHighMinute == DONT_CARE) || (rHighMinute == minute)) && 
				((rHighSecond == DONT_CARE) || (rHighSecond == second)) ) {
					radioAlmStat = ON_HIGH_1;		// WIA[ , 0=Low_OFF, 1=High_ON
			} // end if rHigh
		} else {  // radioAlmStat == ON_HIGH_1
			if (((rLowYear   == DONT_CARE) || (rLowYear   == year)  ) && 
				((rLowMonth  == DONT_CARE) || (rLowMonth  == month) ) && 
				((rLowDate   == DONT_CARE) || (rLowDate   == date)  ) && 
				((rLowWkDay  == DONT_CARE) || (rLowWkDay  == wkDay) ) && 
				((rLowHour   == DONT_CARE) || (rLowHour   == hour)  ) && 
				((rLowMinute == DONT_CARE) || (rLowMinute == minute)) && 
				((rLowSecond == DONT_CARE) || (rLowSecond == second)) ) {
					radioAlmStat = OFF_LOW_0;		// WIA[ , 0=Low_OFF, 1=High_ON
			} // end if rLowXXX
		} // end if radioAlmStat
	} else {  // radioAlmEnable == OFF_LOW_0
		radioAlmStat = OFF_LOW_0;		// WIA[ , 0=Low_OFF, 1=High_ON
	} // end if radioAlmEnable
	disp_radioAlm_Stat();			// WIA[ \
}

