//****************************************
//	rtc-alarm.c   RTCA[
//			Copyright by S.Asakura
//****************************************
#include 	<m8c.h>
#include 	"PSoCAPI.h" 	// PSoC API definitions for all User Modules
#include	"printf.h"		// printf to
#include	"message.h"		// bZ[W\
#include	"rtc-inner.h"	// RTCA^C NbN

//*******************************
//		֐vg^Cv錾
//*******************************
#define 	FIRST_FLG		// ŏɕϐ̒`A2ڈȍ~͊Oϐ錾邽߂̃tO
#include	"rtc-alarm.h"	// RTCA[


//*******************************
//		萔 `
//*******************************


//*******************************
//		O[oϐ
//*******************************
	unsigned char	rtcAlmPoutDatBuf;	// RTCA[o̓|[gf[^obt@
	unsigned char	aHighDT[16] = A_ALM_INI_H;		// RTCA[High ftHgl
	unsigned char	aLowDT[16]  = A_ALM_INI_L;		// RTCA[Low  ftHgl

	unsigned char	aHighSecond;	// 0-59 secondsA[HIGH
	unsigned char	aHighMinute;	// 0-59 minutesA[HIGH
	unsigned char	aHighHour;		// 0-23 hoursA[HIGH
	unsigned char	aHighDate;		// 1-31 daysA[HIGH
	unsigned char	aHighWkDay;		// 0-6 (Sunday=0, Saturday=6)A[HIGH
	unsigned char	aHighMonth;		// 1-12 monthsA[HIGH
	unsigned short	aHighYear;		// 0-9999 yearA[HIGH

	unsigned char	aLowSecond;		// 0-59 secondsA[LOW
	unsigned char	aLowMinute;		// 0-59 minutesA[LOW
	unsigned char	aLowHour;		// 0-23 hoursA[LOW
	unsigned char	aLowDate;		// 1-31 daysA[LOW
	unsigned char	aLowWkDay;		// 0-6 (Sunday=0, Saturday=6)A[LOW
	unsigned char	aLowMonth;		// 1-12 monthsA[LOW
	unsigned short	aLowYear;		// 0000-9999 yearA[LOW


//=============================================================================

//*******************************
// ASCII ͈͔
//*******************************
unsigned char isAsciiNumRange(unsigned char c, unsigned char sNum, unsigned char eNum) {
	if (c >= ('0' + sNum) && c <= ('0' + eNum)) {		// ASCII ͈
		return(1);
	} else {
		return(0);
	} // end if
}

//*******************************
// ChJ[h
//*******************************
unsigned char isWild(unsigned char c) {
	if (c == '?' || c == 'X' || c == 'x') {
		return(1);
	} else {
		return(0);
	} // end if
}

//*******************************
// RTCA[ON/OFF , 0=OFF=Low , 1=ON=High
//*******************************
void rtcAlm_OnOff(unsigned char onOff) {
	extern	unsigned char	rtcAlmPoutDatBuf;	// RTCA[o̓|[gf[^obt@
	extern	unsigned char	rtcAlmStat;			// RTCA[o͏   , 0=Low_OFF, 1=High_ON

	if (onOff == ON_HIGH_1) {
		rtcAlmPoutDatBuf |= RTC_ALM_BIT;		// High, ON
		rtcAlmStat = ON_HIGH_1;			// RTCA[o͏   , 0=Low_OFF, 1=High_ON
	} else {
		rtcAlmPoutDatBuf &= ~(RTC_ALM_BIT);		// Low, OFF
		rtcAlmStat = OFF_LOW_0;			// RTCA[o͏   , 0=Low_OFF, 1=High_ON
	} // end if
	RTC_ALM_PORT = rtcAlmPoutDatBuf;
}

//*******************************
// RTCA[ݒ S\
//*******************************
void disp_rtcAlm_Set(void) {
	extern	unsigned char	aHighDT[16];		// RTCA[High ftHgl , 0000b
	extern	unsigned char	aLowDT[16] ;		// RTCA[Low  ftHgl , 0001b
	extern	unsigned char	rtcAlmStat;			// RTCA[o͏   , 0=Low_OFF, 1=High_ON
	extern	unsigned char	rtcAlmEnable;		// RTCA[Enable , 0=Disable, 1=Enable

	UART_1_CPutString("RTC-Alarm = ");
	if (rtcAlmEnable == ON_HIGH_1) {
		msg_Enable();			// \_Enable
	} else {
		msg_Disable();			// \_Disable
	}
	UART_1_PutCRLF();			// s(CR,LF)

	msg_HighSet();				// \_High Set =
	UART_1_PutString( aHighDT );
	UART_1_PutCRLF();			// s(CR,LF)
	msg_LowSet();				// \_Low Set =
	UART_1_PutString( aLowDT );
	UART_1_PutCRLF();			// s(CR,LF)

	UART_1_CPutString(" P00 Stat = ");
	if (rtcAlmStat == ON_HIGH_1) {
		msg_ON_HIGH_1();		// \_ON_HIGH_1
	} else {
		msg_OFF_LOW_0();		// \_OFF_LOW_0
	}
	UART_1_PutCRLF();		// s(CR,LF)
}

//*******************************
// RTCA[ \
//*******************************
void disp_rtcAlm_Stat(void) {
	extern	unsigned char	rtcAlmStat;			// RTCA[o͏   , 0=Low_OFF, 1=High_ON
	extern	unsigned char	preRtcAlmStat;		// ORTCA[o͏

	if ( rtcAlmStat != preRtcAlmStat) {
		UART_1_CPutString(" , T_Alm-");
		if (rtcAlmStat == ON_HIGH_1) {
			UART_1_CPutString("ON");
		} else {
			UART_1_CPutString("OFF");
		}
		preRtcAlmStat = rtcAlmStat;		// ORTCA[o͏
	} // end if
}

//*******************************
// RTCA[
//*******************************
void init_rtcAlarm(void) {
	extern	unsigned char	rtcAlmPoutDatBuf;	// RTCA[o̓|[gf[^obt@
	extern	unsigned char	rtcAlmStat;		// tA[o͏
	extern	unsigned char	preRtcAlmStat;	// ORTCA[o͏
	extern	unsigned char	rtcAlmEnable;	// tA[Enable , 0=Disable, 1=Enable

	rtcAlmPoutDatBuf = 0;				// vAbvXCb`w肷BƂ肠A݂͖B
	RTC_ALM_PORT = rtcAlmPoutDatBuf;	// ̓XCb`pvAbvo
	rtcAlm_OnOff(OFF_LOW_0);		// RTCA[ON/OFF , 0=OFF=Low , 1=ON=High
	rtcAlmStat   = OFF_LOW_0;		// RTCA[o͏   , 0=Low_OFF, 1=High_ON
	rtcAlmEnable = OFF_LOW_0;		// RTCA[Enable , 0=Disable, 1=Enable
	preRtcAlmStat = rtcAlmStat;		// ORTCA[o͏
	chg_aDT_num(&aHighDT[0], ON_HIGH_1);	// RTCA[t_ݒl_lϊ
	chg_aDT_num( &aLowDT[0], OFF_LOW_0);	// RTCA[t_ݒl_lϊ
}

//********************
// HELP RTCA[ R}h('A')
//********************
void help_rtcAlarm(void) {
	UART_1_CPutString(" AH(DateTime) : RTC-Alarm-High");
	UART_1_PutCRLF();		// s(CR,LF)
	UART_1_CPutString(" AL(DateTime) : RTC-Alarm-Low");
	UART_1_PutCRLF();		// s(CR,LF)
	msg_Help_DateTime();	// \_HELP_DateTime
	UART_1_CPutString(" AEx : RTC-Alarm-Enable , x=0:Disable and P00_LOW , x=1:Enable");
	UART_1_PutCRLF();		// s(CR,LF)
}

//*******************************
// RTCA[ R}h('A') 
//*******************************
void cmdBR_rtcAlarm(unsigned char *sPtr) {
	extern	unsigned char	rtcAlmEnable;	// tA[Enable , 0=Disable, 1=Enable
	unsigned char *strPtr;

	set_prtdev_sio(); 				// \uSIO(UART)ɂ
	strPtr = sPtr;
	strPtr++;
	switch (*strPtr) {
		case 'H' : 		// A[HIGHݒ
		case 'h' : 
			strPtr++;
			if (chk_AlmFormat(strPtr)) {					// A[t_tH[}bg`FbN
				copyStr_rtcAlmSet( &aHighDT[0], strPtr);	// RTCA[ݒ_Rs[(15+00 p)
				chg_aDT_num( &aHighDT[0], ON_HIGH_1);		// RTCA[t_ݒl_lϊ
				disp_rtcAlm_Set();			// RTCA[ݒ S\
			} else {
				msg_FmtError();		// \_Format_Error
				help_rtcAlarm();	// HELP RTCA[ R}h('A')
				disp_rtcAlm_Set();	// RTCA[ݒ S\
			} // end if 
			break;
		case 'L' : 		// A[LOWݒ
		case 'l' : 
			strPtr++;
			if (chk_AlmFormat(strPtr)) {					// A[t_tH[}bg`FbN
				copyStr_rtcAlmSet( &aLowDT[0], strPtr);		// RTCA[ݒ_Rs[(15+00 p)
				chg_aDT_num( &aLowDT[0], OFF_LOW_0);		// RTCA[t_ݒl_lϊ
				disp_rtcAlm_Set();			// RTCA[ݒ S\
			} else {
				msg_FmtError();		// \_Format_Error
				help_rtcAlarm();	// HELP RTCA[ R}h('A')
				disp_rtcAlm_Set();	// RTCA[ݒ S\
			} // end if 
			break;
		case 'E' : 		// A[Enableݒ
		case 'e' : 
			strPtr++;
			if (*strPtr == '0') {
				rtcAlmEnable = OFF_LOW_0;	// tA[Enable , 0=Disable, 1=Enable
				rtcAlm_OnOff( OFF_LOW_0 );	// RTCA[ON/OFF , 0=OFF=Low , 1=ON=High
			} else {
				rtcAlmEnable = ON_HIGH_1;	// tA[Enable , 0=Disable, 1=Enable
			} // end if 
			disp_rtcAlm_Set();		// RTCA[ݒ S\
			break;
		default : 
			msg_InvalCmd();		// \_R}h
			help_rtcAlarm();	// HELP RTCA[ R}h('A')
			break;
	} // end switch cmd[1]
}

//*******************************
// A[t_tH[}bg`FbN
//*******************************
BOOL chk_AlmFormat(unsigned char *aStr) {
	unsigned char	*strPtr;

	// N[0-3]A[4-5]A[6-7]Aj[8]AA[9-10]A[11-12]Ab[13-14]A00[15]
	strPtr = aStr;		// N
	if ( !(
		 ( isWild(*strPtr) && isWild(*(strPtr+1)) && isWild(*(strPtr+2)) && isWild(*(strPtr+3)) ) // 4ƂChJ[h
		 || ( isAsciiNumRange(*strPtr, 0, 9) && isAsciiNumRange(*(strPtr + 1), 0, 9) 
				&& isAsciiNumRange(*(strPtr + 2), 0, 9) && isAsciiNumRange(*(strPtr + 3), 0, 9) ) // 4Ƃ
		   ) ) {
		return(FALSE);
	} // end if

	strPtr = aStr + 4;	// 
	if ( !(
		 ( isWild(*strPtr) && isWild(*(strPtr+1)) )		// 2ƂChJ[h
		 || ( (*strPtr == '0') && isAsciiNumRange(*(strPtr + 1), 1, 9) )	// 01-09
		 || ( (*strPtr == '1') && isAsciiNumRange(*(strPtr + 1), 0, 2) )	// 10-12
		   ) ) {
		return(FALSE);
	} // end if

	strPtr = aStr + 6;	//  , `FbN͂Ŋȗ , 2̓`FbNȂ
	if ( !(
		 ( isWild(*strPtr) && isWild(*(strPtr+1)) )		// 2ƂChJ[h
		 || ( (*strPtr == '0') &&  isAsciiNumRange(*(strPtr + 1), 1, 9) )				// 01-09
		 || ( isAsciiNumRange(*strPtr, 1, 2) && isAsciiNumRange(*(strPtr + 1), 0, 9) )	// 10-29
		 || ( (*strPtr == '3') &&  isAsciiNumRange(*(strPtr + 1), 0, 1) )				// 30-31
		  ) ) {
		return(FALSE);
	} // end if

	strPtr = aStr + 8;	// j
	if ( ! (
		isWild(*strPtr) || isAsciiNumRange(*strPtr, 0, 6)		// 0-6j
		  ) ) {
		return(FALSE);
	} // end if

	strPtr = aStr + 9;	// 
	if ( !(
		( isWild(*strPtr) && isWild(*(strPtr+1)) )		// 2ƂChJ[h
		 || ( isAsciiNumRange(*strPtr, 0, 1) && isAsciiNumRange(*(strPtr + 1), 0, 9) )	// 00-19
		 || ( (*strPtr == '2') &&  isAsciiNumRange(*(strPtr + 1), 0, 3) )				// 20-23
		  ) ) {
		return(FALSE);
	} // end if

	strPtr = aStr + 11;	// 
	if ( ! (
		( isWild(*strPtr) && isWild(*(strPtr+1)) )		// 2ƂChJ[h
		 || ( isAsciiNumRange(*strPtr, 0, 5) && isAsciiNumRange(*(strPtr + 1), 0, 9) )	// 00-59
		  ) ) {
		return(FALSE);
	} // end if

	strPtr = aStr + 13;	// b
	if ( ! (
		( isWild(*strPtr) && isWild(*(strPtr+1)) )		// 2ƂChJ[h
		 || ( isAsciiNumRange(*strPtr, 0, 5) && isAsciiNumRange(*(strPtr + 1), 0, 9) )	// 00-59b
		  ) ) {
		return(FALSE);
	} // end if
	return(TRUE);
}

//*******************************
// RTCA[ݒ_Rs[(15+00 p)
//*******************************
void copyStr_rtcAlmSet(unsigned char *tar, unsigned char *org) {
	unsigned char i;
	unsigned char *orgStrPtr;	// Origin
	unsigned char *tarStrPtr;	// Target

	orgStrPtr = org;	// Origin
	tarStrPtr = tar;	// Target
	for (i = 0; i <= 14; i++) {
		*tarStrPtr++ = *orgStrPtr++;
	} // end for i
	*tarStrPtr = 0x00;
}

//*******************************
// RTCA[t_ݒl_lϊ
//*******************************
void chg_aDT_num(unsigned char *aStr, unsigned char onoff) {
	extern	unsigned char	aHighSecond;	// 0-59 secondsA[HIGH
	extern	unsigned char	aHighMinute;	// 0-59 minutesA[HIGH
	extern	unsigned char	aHighHour;		// 0-23 hoursA[HIGH
	extern	unsigned char	aHighDate;		// 1-31 daysA[HIGH
	extern	unsigned char	aHighWkDay;		// 0-6 (Sunday=0, Saturday=6)A[HIGH
	extern	unsigned char	aHighMonth;		// 1-12 monthsA[HIGH
	extern	unsigned short	aHighYear;		// 0-9999 yearA[HIGH

	extern	unsigned char	aLowSecond;		// 0-59 secondsA[LOW
	extern	unsigned char	aLowMinute;		// 0-59 minutesA[LOW
	extern	unsigned char	aLowHour;		// 0-23 hoursA[LOW
	extern	unsigned char	aLowDate;		// 1-31 daysA[LOW
	extern	unsigned char	aLowWkDay;		// 0-6 (Sunday=0, Saturday=6)A[LOW
	extern	unsigned char	aLowMonth;		// 1-12 monthsA[LOW
	extern	unsigned short	aLowYear;		// 0-9999 yearA[LOW

	unsigned char	*strPtr;
	unsigned short	nYear;
	unsigned char	nMonth , nDate , nWkDay, nLeap;
	unsigned char	nHour , nMin , nSec;

	// N[0-3]A[4-5]A[6-7]Aj[8]AA[9-10]A[11-12]Ab[13-14]A00[15]
	strPtr = aStr;	// N
	if (*strPtr == '?' || *strPtr == 'X' || *strPtr == 'x') {
		nYear = DONT_CARE;	// N
	} else {
		nYear   = (unsigned short)(((*strPtr++) - '0') * 1000);
		nYear  += (unsigned short)(((*strPtr++) - '0') *  100);
		nYear  += (unsigned short)(((*strPtr++) - '0') *   10);
		nYear  += (unsigned short)(((*strPtr  ) - '0')       );
	} // end if

	strPtr = aStr + 4;	// 
	if (*strPtr == '?' || *strPtr == 'X' || *strPtr == 'x') {
		nMonth = DONT_CARE;	// 
	} else {
		nMonth  = (((*strPtr++) - '0') * 10);
		nMonth += (((*strPtr  ) - '0')     );
	} // end if

	strPtr = aStr + 6;	// 
	if (*strPtr == '?' || *strPtr == 'X' || *strPtr == 'x') {
		nDate = DONT_CARE;	// 
	} else {
		nDate   = (((*strPtr++) - '0') * 10);
		nDate  += (((*strPtr  ) - '0')     );
	} // end if

	strPtr = aStr + 8;	// j
	if (*strPtr == '?' || *strPtr == 'X' || *strPtr == 'x') {
		nWkDay = DONT_CARE;	//  Don't Care
	} else {
		nWkDay  =  ((*strPtr)   - '0');
	} // end if

	strPtr = aStr + 9;	// 
	if (*strPtr == '?' || *strPtr == 'X' || *strPtr == 'x') {
		nHour = DONT_CARE;	// 
	} else {
		nHour = (((*strPtr++) - '0') * 10);
		nHour+= (((*strPtr  ) - '0')     );
	} // end if

	strPtr = aStr + 11;	// 
	if (*strPtr == '?' || *strPtr == 'X' || *strPtr == 'x') {
		nMin = DONT_CARE;	// 
	} else {
		nMin  = (((*strPtr++) - '0') * 10);
		nMin += (((*strPtr  ) - '0')     );
	} // end if

	strPtr = aStr + 13;	// b
	if (*strPtr == '?' || *strPtr == 'X' || *strPtr == 'x') {
		nSec = DONT_CARE;	// b
	} else {
		nSec  = (((*strPtr++) - '0') * 10);
		nSec += (((*strPtr)   - '0')     );
	} // end if

	if (onoff == 1) {
		aHighYear   = nYear;
		aHighMonth  = nMonth;
		aHighDate   = nDate;
		aHighWkDay  = nWkDay;
		aHighSecond = nSec;			// b
		aHighMinute = nMin;			// 
		aHighHour   = nHour;		// 
	} else {
		aLowYear   = nYear;
		aLowMonth  = nMonth;
		aLowDate   = nDate;
		aLowWkDay  = nWkDay;
		aLowSecond = nSec;			// b
		aLowMinute = nMin;			// 
		aLowHour   = nHour;			// 
	} // end if onoff
}

//*******************************
// RTCA[_`FbN
//*******************************
void chk_rtcAlarm(void) {
	extern	unsigned char	second;		// 0-59 seconds
	extern	unsigned char	minute;		// 0-59 minutes
	extern	unsigned char	hour;		// 0-23 hours
	extern	unsigned char	date;		// 1-31 days
	extern	unsigned char	wkDay;		// 0-6 (Sunday=0, Saturday=6)
	extern	unsigned char	month;		// 1-12 months
	extern	unsigned short	year;		// 0-9999 year

	extern	unsigned char	aHighSecond;	// 0-59 secondsA[HIGH
	extern	unsigned char	aHighMinute;	// 0-59 minutesA[HIGH
	extern	unsigned char	aHighHour;		// 0-23 hoursA[HIGH
	extern	unsigned char	aHighDate;		// 1-31 daysA[HIGH
	extern	unsigned char	aHighWkDay;		// 0-6 (Sunday=0, Saturday=6)A[HIGH
	extern	unsigned char	aHighMonth;		// 1-12 monthsA[HIGH
	extern	unsigned short	aHighYear;		// 0-9999 yearA[HIGH

	extern	unsigned char	aLowSecond;		// 0-59 secondsA[LOW
	extern	unsigned char	aLowMinute;		// 0-59 minutesA[LOW
	extern	unsigned char	aLowHour;		// 0-23 hoursA[LOW
	extern	unsigned char	aLowDate;		// 1-31 daysA[LOW
	extern	unsigned char	aLowWkDay;		// 0-6 (Sunday=0, Saturday=6)A[LOW
	extern	unsigned char	aLowMonth;		// 1-12 monthsA[LOW
	extern	unsigned short	aLowYear;		// 0-9999 yearA[LOW

	extern	unsigned char	rtcAlmStat;		// RTCA[o͏ , 0=Low_OFF, 1=High_ON
	extern	unsigned char	rtcAlmEnable;	// tA[Enable , 0=Disable, 1=Enable

	if (rtcAlmEnable == ON_HIGH_1) {
		if (rtcAlmStat == OFF_LOW_0) {
			if (((aHighYear   == DONT_CARE) || (aHighYear   == year)  ) && 
				((aHighMonth  == DONT_CARE) || (aHighMonth  == month) ) && 
				((aHighDate   == DONT_CARE) || (aHighDate   == date)  ) && 
				((aHighWkDay  == DONT_CARE) || (aHighWkDay  == wkDay) ) && 
				((aHighHour   == DONT_CARE) || (aHighHour   == hour)  ) && 
				((aHighMinute == DONT_CARE) || (aHighMinute == minute)) && 
				((aHighSecond == DONT_CARE) || (aHighSecond == second)) ) {
					rtcAlm_OnOff( ON_HIGH_1 );		// RTCA[ON/OFF , 0=OFF=Low , 1=ON=High
			} // end if aHigh
		} else {  // rtcAlmStat == ON_HIGH_1
			if (((aLowYear   == DONT_CARE) || (aLowYear   == year)  ) && 
				((aLowMonth  == DONT_CARE) || (aLowMonth  == month) ) && 
				((aLowDate   == DONT_CARE) || (aLowDate   == date)  ) && 
				((aLowWkDay  == DONT_CARE) || (aLowWkDay  == wkDay) ) && 
				((aLowHour   == DONT_CARE) || (aLowHour   == hour)  ) && 
				((aLowMinute == DONT_CARE) || (aLowMinute == minute)) && 
				((aLowSecond == DONT_CARE) || (aLowSecond == second)) ) {
					rtcAlm_OnOff( OFF_LOW_0 );		// RTCA[ON/OFF , 0=OFF=Low , 1=ON=High
			} // end if aLowXXX
		} // end if rtcAlmStat
	} else {  // rtcAlmEnable == OFF_LOW_0
		rtcAlm_OnOff( OFF_LOW_0 );		// RTCA[ON/OFF , 0=OFF=Low , 1=ON=High
	} // end if rtcAlmEnable
}

